#!/usr/bin/env python3
#
# Orion Rigel --- Text to Speech engine
#
#   Copyright (c) 2022  Sameer Rahmani <lxsameer@gnu.org>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 2 of the License.
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#   You should have received a copy of the GNU General Public License

import sys
import asyncio

import dotenv

from tcp import start, synth


def main():
    config = dotenv.dotenv_values(sys.argv[1])

    try:
        asyncio.run(start(config, synth(config)))
    except KeyboardInterrupt:
        sys.exit()


if __name__ == "__main__":
    main()
